#!/usr/bin/env node
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import inquirer from 'inquirer';
const ui = new inquirer.ui.BottomBar();
import { installAppiumServer, getDriver, installDrivers, installPlugin, runAppiumDoctor } from './serverInstall.js';
import chalk from 'chalk';
function main() {
    return __awaiter(this, void 0, void 0, function* () {
        ui.log.write(`\n👋 Hello, Appium user ✨\n\n`);
        ui.log.write(`\n\n‼️  BEFORE YOU START:\n\n`);
        ui.log.write(`🐍 Make sure you have node 16 and above\n\n`);
        const { server } = yield inquirer.prompt([
            {
                type: 'confirm',
                message: 'Do you want to install appium server',
                name: 'server',
            },
        ]);
        function skipInstall(value) {
            ui.log.write('\n');
            ui.log.write(chalk.yellow(value));
            ui.log.write('\n');
        }
        server === true
            ? yield installAppiumServer()
            : skipInstall('Appium Server installation skipped');
        const { drivers } = yield inquirer.prompt([
            {
                type: 'confirm',
                message: 'Do you want to install appium drivers',
                name: 'drivers',
            },
        ]);
        function installRequiredDrivers() {
            return __awaiter(this, void 0, void 0, function* () {
                const driverChoices = yield getDriver();
                const requiredDriverToInstall = yield inquirer.prompt([
                    {
                        type: 'checkbox',
                        message: 'Select Drivers to install',
                        name: 'drivers',
                        choices: driverChoices,
                    },
                ]);
                yield installDrivers(requiredDriverToInstall.drivers);
                ui.log.write('\n');
            });
        }
        drivers === true ? yield installRequiredDrivers() : skipInstall('Appium Driver installation skipped');
        const { plugin } = yield inquirer.prompt([
            {
                type: 'confirm',
                message: 'Do you want to install appium plugin',
                name: 'plugin',
            },
        ]);
        plugin === true
            ? yield installPlugin()
            : skipInstall('Appium Plugin installation skipped');
        ui.log.write('\n');
        const { doctor } = yield inquirer.prompt([
            {
                type: 'confirm',
                message: 'Do you want to run appium-doctor',
                name: 'doctor',
            },
        ]);
        doctor === true
            ? yield runAppiumDoctor()
            : skipInstall('Appium Doctor check skipped');
        ui.log.write('\n');
        ui.log.write('\n');
        ui.log.write('✨ All done! Thanks for using the Appium Installer');
    });
}
main();
//# sourceMappingURL=index.js.map